// rdparse.cpp
// Glenn G. Chappell
// 8 Feb 2013
//
// For CS 331 Spring 2013
// Source for class RDParse
// First Recursive-Descent Parser

#include "rdparse.h"  // For class RDParse
#include <string>
using std::string;


// Parsing functions for nonterminals in the grammar
// Each function parses the nonterminal in its name. A true return
//  value means a correct parse, and the current lexeme is just past
//  the end of the string the nonterminal expanded into. A false
//  return means an invorrect parse; in this case the current lexeme
//  is undefined.
//
// See the header file for the grammar.

// parse_thing
bool RDParse::parse_thing()
{
    if (matchString("("))
    {  // Handle "(" thing ")"
        if (!parse_thing()) return false;
        if (!matchString(")")) return false;
    }
    else if (matchString("["))
    {  // Handle "[" thing "]"
        if (!parse_thing()) return false;
        if (!matchString("]")) return false;
    }
    else if (matchToken(Lex::ID))
    {  // Handle ID [ ":" num_list ]
        if (matchString(":"))
        {
            if (!parse_num_list()) return false;
        }
    }
    else
    {  // First lexeme is not one of the options
        return false;
    }

    // All done
    return true;
}

// parse_num_list
bool RDParse::parse_num_list()
{
    if (!matchToken(Lex::NUM)) return false;
    if (matchString(","))
    {
        if (!matchToken(Lex::NUM)) return false;
        if (matchString(","))
        {
            if (!matchToken(Lex::NUM)) return false;
        }
    }

    // All done
    return true;
}

